﻿Imports System.Windows.Media
Imports System.Windows.Controls

Public Class ScrollViewerThumbnail
	Inherits Windows.Controls.Control

	Public Sub New()
		DefaultStyleKeyProperty.OverrideMetadata(GetType(ScrollViewerThumbnail), New Windows.FrameworkPropertyMetadata(GetType(ScrollViewerThumbnail)))
	End Sub

	Public Property ScrollViewer() As Windows.Controls.ScrollViewer
		Get
			Return DirectCast(GetValue(ScrollViewerProperty), Windows.Controls.ScrollViewer)
		End Get
		Set(ByVal value As Windows.Controls.ScrollViewer)
			SetValue(ScrollViewerProperty, value)
		End Set
	End Property

	Public Property HighlightFill() As Brush
		Get
			Return DirectCast(GetValue(HighlightFillProperty), Brush)
		End Get
		Set(ByVal value As Brush)
			SetValue(HighlightFillProperty, value)
		End Set
	End Property

	Public Shared ReadOnly ScrollViewerProperty As Windows.DependencyProperty = Windows.DependencyProperty.Register("ScrollViewer", GetType(ScrollViewer), GetType(ScrollViewerThumbnail), New Windows.UIPropertyMetadata(Nothing))
	Public Shared ReadOnly HighlightFillProperty As Windows.DependencyProperty = Windows.DependencyProperty.Register("HighlightFill", GetType(Brush), GetType(ScrollViewerThumbnail), New Windows.UIPropertyMetadata(New SolidColorBrush(Color.FromArgb(64, 255, 255, 0))))

	Private Const ThumbName As String = "ThumbHighlight"

	Public Overrides Sub OnApplyTemplate()
		MyBase.OnApplyTemplate()
		Dim PartHighlight As Windows.Controls.Primitives.Thumb
		PartHighlight = DirectCast(Me.Template.FindName(ThumbName, Me), Windows.Controls.Primitives.Thumb)
		AddHandler PartHighlight.DragDelta, AddressOf PartHighlight_DragDelta
	End Sub

	Private Sub PartHighlight_DragDelta(ByVal sender As Object, ByVal e As Windows.Controls.Primitives.DragDeltaEventArgs)
		ScrollViewer.ScrollToVerticalOffset(ScrollViewer.VerticalOffset + e.VerticalChange)
		ScrollViewer.ScrollToHorizontalOffset(ScrollViewer.HorizontalOffset + e.HorizontalChange)
	End Sub

End Class
